searchData={"content_type":"text/markdown","items":[{"doc":"# FastPostmanCollection\n\nThis library exists for generate your collection by Phoenix Router `MyApp.Router`.\nYou can write your documentation by `@doc`\nThis library release this scheme: https://schema.postman.com/\nExample generative your collection:\n![collection](assets/collection.png)","ref":"FastPostmanCollection.html","title":"FastPostmanCollection","type":"module"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `fast_postman_collection` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:fast_postman_collection, \"~> 0.1.7\"}\n  ]\nend\n```\n\nConfigure fast collection\n\n- pipe_tokens -> put in your auth bearer\n- router -> your router\n- variables -> variables collection\n- file_path_collection -> rewrite where will be your file collection\n\n```elixir\nconfig(:fast_postman_collection,\n  pipe_tokens: [:admin_auth, :user_auth],\n  name_collection: \"My collection\",\n  router: MyApp.Router,\n  variables: [\n    %{\n      key: \"host\",\n      value: \"http://localhost:4000\"\n    }\n  ]\n)\n```\n\nconfigure your controller\n\n```elixir\ndefmodule TestAppWeb.UserController do\n  use TestAppWeb, :controller\n  @moduledoc filter: \"test\"\n  # Artem will be name in collection\n  @moduledoc \"\"\"\n  # Artem\n  \"\"\"\n  # Index route will be name in collection\n  @doc \"\"\"\n  # Index route\n  This route will be in collection\n  \"\"\"\n  @doc params: %{\n    limit: 0,\n    page: %{\n      key: \"page\",\n      value: 1,\n      description: \"artem\"\n    },\n  }\n  def index(conn, params) do\n    json(conn, params)\n  end\nend\n```\n\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"FastPostmanCollection.html#module-installation","title":"Installation - FastPostmanCollection","type":"module"},{"doc":"`mix fs.get_collection`","ref":"FastPostmanCollection.html#module-mix-command-for-generate","title":"Mix command for generate - FastPostmanCollection","type":"module"},{"doc":"- 0.1.7: Added support for including endpoint descriptions in Postman collections \n- 0.1.6: Previous version","ref":"FastPostmanCollection.html#module-changelog","title":"Changelog - FastPostmanCollection","type":"module"},{"doc":"","ref":"FastPostmanCollection.html#module-how-to-write-documenation","title":"How to write documenation - FastPostmanCollection","type":"module"},{"doc":"![naming](assets/naming.png)\n\n```elixir\n  @moduledoc \"\"\"\n  # Post controller\n  \"\"\"\n  # Create post go to naming\n  @doc \"\"\"\n  # Create post\n  this description go to doc !!!!!\n  \"\"\"\n```\n\nif you don't pass @doc with # FastPostmanCollection pass module name or function name","ref":"FastPostmanCollection.html#module-naming","title":"naming - FastPostmanCollection","type":"module"},{"doc":"This will be put on your url as limit?=10\n\n```elixir\n@doc params: %{\n    limit: 0,\n    page: %{\n      key: \"page\",\n      value: 1,\n      description: \"artem\"\n    },\n  }\n  def index(conn, params) do\n    json(conn, params)\n  end\n```\n\n![params](assets/params.png)\nThis will be put on your body and automate mode will be json\n\n```elixir\n @doc \"\"\"\n  # Create post\n  \"\"\"\n  @doc body: %{\n         post: %{\n           title: \"\"\n         }\n       }\n  def create_post(conn, params) do\n    json(conn, params)\n  end\n```\n\n![body](assets/body.png)\nfomdata options\n\n```elixir\n @doc mode: \"formdata\"\n@doc formdata: [\n         %{\n           key: \"image\",\n           value: nil,\n           type: \"file\"\n         }\n       ]\n```","ref":"FastPostmanCollection.html#module-params","title":"params - FastPostmanCollection","type":"module"},{"doc":"All tokens puts and scans from your pipelines","ref":"FastPostmanCollection.html#module-about-authrization","title":"About authrization - FastPostmanCollection","type":"module"},{"doc":"router.ex\n\n```elixir\n  scope \"/user\" do\n    pipe_through(:admin_auth)\n    get(\"/\", UserController, :index)\n  end\n```\n\nconfig.exs\n\n```elixir\nconfig(:fast_postman_collection,\n  pipe_tokens: [:admin_auth, :user_auth]\n```\n\nwill be there in bearer in token\n![token](assets/token.png)\n\nAnd use for put your token\n\n```elixir\n @doc auth_pre_request: %{is_enabled: true, from_resp_token: \"token\", variable_token: \"admin_variable\"}\n```","ref":"FastPostmanCollection.html#module-example","title":"example - FastPostmanCollection","type":"module"},{"doc":"You can use `@moduledoc folder_path: \"Admin\"`\nand this put your module function to this folder","ref":"FastPostmanCollection.html#module-about-folder","title":"about folder - FastPostmanCollection","type":"module"},{"doc":"```elixir\ndefmodule MyAppWeb.AdminUserController do\n  use MyAppWeb, :controller\n  @moduledoc folder_path: \"Admin\"\n  # this module puts to /admin/user controller\n  @moduledoc \"\"\"\n  # user controller\n  \"\"\"\n\nend\n```","ref":"FastPostmanCollection.html#module-example","title":"Example - FastPostmanCollection","type":"module"},{"doc":"mix fs.get_collection:\nThis command generate in your directory file with collection","ref":"FastPostmanCollection.html#module-mix-commands","title":"mix commands - FastPostmanCollection","type":"module"},{"doc":"- [ ] filtering in mix fs.get_collection\n- [ ] more testing structs generate","ref":"FastPostmanCollection.html#module-todo","title":"Todo - FastPostmanCollection","type":"module"},{"doc":"","ref":"FastPostmanCollection.html#generate/1","title":"FastPostmanCollection.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.html#generate_json/1","title":"FastPostmanCollection.generate_json/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.Collect.html","title":"FastPostmanCollection.Collect","type":"module"},{"doc":"","ref":"FastPostmanCollection.Collect.html#collect_documentation/2","title":"FastPostmanCollection.Collect.collect_documentation/2","type":"function"},{"doc":"","ref":"FastPostmanCollection.Collect.html#generate_data_by_router/1","title":"FastPostmanCollection.Collect.generate_data_by_router/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.CollectDataItem.html","title":"FastPostmanCollection.CollectDataItem","type":"module"},{"doc":"","ref":"FastPostmanCollection.CollectDataItemParams.html","title":"FastPostmanCollection.CollectDataItemParams","type":"module"},{"doc":"","ref":"FastPostmanCollection.CollectDataItemParams.html#get_from_map/1","title":"FastPostmanCollection.CollectDataItemParams.get_from_map/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.CollectDataModule.html","title":"FastPostmanCollection.CollectDataModule","type":"module"},{"doc":"","ref":"FastPostmanCollection.CollectDataModuleParams.html","title":"FastPostmanCollection.CollectDataModuleParams","type":"module"},{"doc":"","ref":"FastPostmanCollection.CollectDataModuleParams.html#get_from_map/1","title":"FastPostmanCollection.CollectDataModuleParams.get_from_map/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.Config.html","title":"FastPostmanCollection.Config","type":"module"},{"doc":"","ref":"FastPostmanCollection.Config.html#get_file_path_to_generate/0","title":"FastPostmanCollection.Config.get_file_path_to_generate/0","type":"function"},{"doc":"","ref":"FastPostmanCollection.Config.html#get_name_collection/0","title":"FastPostmanCollection.Config.get_name_collection/0","type":"function"},{"doc":"","ref":"FastPostmanCollection.Config.html#get_pipe_tokens/0","title":"FastPostmanCollection.Config.get_pipe_tokens/0","type":"function"},{"doc":"","ref":"FastPostmanCollection.Config.html#get_variables/0","title":"FastPostmanCollection.Config.get_variables/0","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.html","title":"FastPostmanCollection.GenerateCollection","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.html#generate/2","title":"FastPostmanCollection.GenerateCollection.generate/2","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.html#generate_to_json/2","title":"FastPostmanCollection.GenerateCollection.generate_to_json/2","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.html#parse_collect_data_item/1","title":"FastPostmanCollection.GenerateCollection.parse_collect_data_item/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.html#parse_collect_data_module/1","title":"FastPostmanCollection.GenerateCollection.parse_collect_data_module/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Auth.html","title":"FastPostmanCollection.GenerateCollection.Structs.Auth","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Auth.html#generate/1","title":"FastPostmanCollection.GenerateCollection.Structs.Auth.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Auth.html#get_config_auth_pipe/1","title":"FastPostmanCollection.GenerateCollection.Structs.Auth.get_config_auth_pipe/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Auth.html#get_variables_tokens/0","title":"FastPostmanCollection.GenerateCollection.Structs.Auth.get_variables_tokens/0","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Body.html","title":"FastPostmanCollection.GenerateCollection.Structs.Body","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Body.html#generate/1","title":"FastPostmanCollection.GenerateCollection.Structs.Body.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Body.html#is_disabled/1","title":"FastPostmanCollection.GenerateCollection.Structs.Body.is_disabled/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Event.html","title":"FastPostmanCollection.GenerateCollection.Structs.Event","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Event.html#generate/1","title":"FastPostmanCollection.GenerateCollection.Structs.Event.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Event.html#generate_auth_pre_request/1","title":"FastPostmanCollection.GenerateCollection.Structs.Event.generate_auth_pre_request/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Folder.html","title":"FastPostmanCollection.GenerateCollection.Structs.Folder","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Formdata.html","title":"FastPostmanCollection.GenerateCollection.Structs.Formdata","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Info.html","title":"FastPostmanCollection.GenerateCollection.Structs.Info","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Item.html","title":"FastPostmanCollection.GenerateCollection.Structs.Item","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Main.html","title":"FastPostmanCollection.GenerateCollection.Structs.Main","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Query.html","title":"FastPostmanCollection.GenerateCollection.Structs.Query","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Query.html#generate/1","title":"FastPostmanCollection.GenerateCollection.Structs.Query.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Request.html","title":"FastPostmanCollection.GenerateCollection.Structs.Request","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Url.html","title":"FastPostmanCollection.GenerateCollection.Structs.Url","type":"module"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Url.html#generate/1","title":"FastPostmanCollection.GenerateCollection.Structs.Url.generate/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.GenerateCollection.Structs.Variable.html","title":"FastPostmanCollection.GenerateCollection.Structs.Variable","type":"module"},{"doc":"","ref":"FastPostmanCollection.Helpers.Map.html","title":"FastPostmanCollection.Helpers.Map","type":"module"},{"doc":"","ref":"FastPostmanCollection.Helpers.Map.html#map_from_struct_recursive/1","title":"FastPostmanCollection.Helpers.Map.map_from_struct_recursive/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.Helpers.Map.html#prepare_folder/1","title":"FastPostmanCollection.Helpers.Map.prepare_folder/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.Helpers.Map.html#to_keyword_list/1","title":"FastPostmanCollection.Helpers.Map.to_keyword_list/1","type":"function"},{"doc":"","ref":"FastPostmanCollection.Helpers.RouterInfo.html","title":"FastPostmanCollection.Helpers.RouterInfo","type":"module"},{"doc":"","ref":"FastPostmanCollection.Helpers.RouterInfo.html#route_info/4","title":"FastPostmanCollection.Helpers.RouterInfo.route_info/4","type":"function"},{"doc":"GENERATE POSTMAN COLECTIONS","ref":"Mix.Tasks.Fs.GetCollection.html","title":"mix fs.get_collection","type":"task"},{"doc":"","ref":"FastPostmanCollection.Expectation.GiveTokenAuth.html","title":"FastPostmanCollection.Expectation.GiveTokenAuth","type":"exception"},{"doc":"","ref":"FastPostmanCollection.Expectation.PhoenixRouterNotFound.html","title":"FastPostmanCollection.Expectation.PhoenixRouterNotFound","type":"exception"},{"doc":"# FastPostmanCollection\n\nThis library exists for generate your collection by Phoenix Router `MyApp.Router`.\nYou can write your documentation by `@doc`\nThis library release this scheme: https://schema.postman.com/\nExample generative your collection:\n![collection](assets/collection.png)","ref":"readme.html","title":"FastPostmanCollection","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `fast_postman_collection` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:fast_postman_collection, \"~> 0.1.7\"}\n  ]\nend\n```\n\nConfigure fast collection\n\n- pipe_tokens -> put in your auth bearer\n- router -> your router\n- variables -> variables collection\n- file_path_collection -> rewrite where will be your file collection\n\n```elixir\nconfig(:fast_postman_collection,\n  pipe_tokens: [:admin_auth, :user_auth],\n  name_collection: \"My collection\",\n  router: MyApp.Router,\n  variables: [\n    %{\n      key: \"host\",\n      value: \"http://localhost:4000\"\n    }\n  ]\n)\n```\n\nconfigure your controller\n\n```elixir\ndefmodule TestAppWeb.UserController do\n  use TestAppWeb, :controller\n  @moduledoc filter: \"test\"\n  # Artem will be name in collection\n  @moduledoc \"\"\"\n  # Artem\n  \"\"\"\n  # Index route will be name in collection\n  @doc \"\"\"\n  # Index route\n  This route will be in collection\n  \"\"\"\n  @doc params: %{\n    limit: 0,\n    page: %{\n      key: \"page\",\n      value: 1,\n      description: \"artem\"\n    },\n  }\n  def index(conn, params) do\n    json(conn, params)\n  end\nend\n```\n\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation","title":"Installation - FastPostmanCollection","type":"extras"},{"doc":"`mix fs.get_collection`","ref":"readme.html#mix-command-for-generate","title":"Mix command for generate - FastPostmanCollection","type":"extras"},{"doc":"- 0.1.7: Added support for including endpoint descriptions in Postman collections \n- 0.1.6: Previous version","ref":"readme.html#changelog","title":"Changelog - FastPostmanCollection","type":"extras"},{"doc":"","ref":"readme.html#how-to-write-documenation","title":"How to write documenation - FastPostmanCollection","type":"extras"},{"doc":"![naming](assets/naming.png)\n\n```elixir\n  @moduledoc \"\"\"\n  # Post controller\n  \"\"\"\n  # Create post go to naming\n  @doc \"\"\"\n  # Create post\n  this description go to doc !!!!!\n  \"\"\"\n```\n\nif you don't pass @doc with # FastPostmanCollection pass module name or function name","ref":"readme.html#naming","title":"naming - FastPostmanCollection","type":"extras"},{"doc":"This will be put on your url as limit?=10\n\n```elixir\n@doc params: %{\n    limit: 0,\n    page: %{\n      key: \"page\",\n      value: 1,\n      description: \"artem\"\n    },\n  }\n  def index(conn, params) do\n    json(conn, params)\n  end\n```\n\n![params](assets/params.png)\nThis will be put on your body and automate mode will be json\n\n```elixir\n @doc \"\"\"\n  # Create post\n  \"\"\"\n  @doc body: %{\n         post: %{\n           title: \"\"\n         }\n       }\n  def create_post(conn, params) do\n    json(conn, params)\n  end\n```\n\n![body](assets/body.png)\nfomdata options\n\n```elixir\n @doc mode: \"formdata\"\n@doc formdata: [\n         %{\n           key: \"image\",\n           value: nil,\n           type: \"file\"\n         }\n       ]\n```","ref":"readme.html#params","title":"params - FastPostmanCollection","type":"extras"},{"doc":"All tokens puts and scans from your pipelines","ref":"readme.html#about-authrization","title":"About authrization - FastPostmanCollection","type":"extras"},{"doc":"router.ex\n\n```elixir\n  scope \"/user\" do\n    pipe_through(:admin_auth)\n    get(\"/\", UserController, :index)\n  end\n```\n\nconfig.exs\n\n```elixir\nconfig(:fast_postman_collection,\n  pipe_tokens: [:admin_auth, :user_auth]\n```\n\nwill be there in bearer in token\n![token](assets/token.png)\n\nAnd use for put your token\n\n```elixir\n @doc auth_pre_request: %{is_enabled: true, from_resp_token: \"token\", variable_token: \"admin_variable\"}\n```","ref":"readme.html#example","title":"example - FastPostmanCollection","type":"extras"},{"doc":"You can use `@moduledoc folder_path: \"Admin\"`\nand this put your module function to this folder","ref":"readme.html#about-folder","title":"about folder - FastPostmanCollection","type":"extras"},{"doc":"```elixir\ndefmodule MyAppWeb.AdminUserController do\n  use MyAppWeb, :controller\n  @moduledoc folder_path: \"Admin\"\n  # this module puts to /admin/user controller\n  @moduledoc \"\"\"\n  # user controller\n  \"\"\"\n\nend\n```","ref":"readme.html#example","title":"Example - FastPostmanCollection","type":"extras"},{"doc":"mix fs.get_collection:\nThis command generate in your directory file with collection","ref":"readme.html#mix-commands","title":"mix commands - FastPostmanCollection","type":"extras"},{"doc":"- [ ] filtering in mix fs.get_collection\n- [ ] more testing structs generate","ref":"readme.html#todo","title":"Todo - FastPostmanCollection","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}